#include <string.h>
#include <stdio.h>
#include "usart.h"
#include "as608.h"
#include "LCD.h"
#include "key.h"
#include "gui_guider.h"
#include "events_init.h"
#include "syn6288.h"
extern u8 as608_cotrol;//лָƹܣ0Ϊʶָƣ1Ϊ¼ָƣ3Ϊɾָ
extern u8 processnum;//¼ָƵĲ

extern u8 press_FR_data;

u8 ID_NUMBER;//ָIDҽΪ1Ϊ2

/*ڽжϴstm32f1xx_it.c*/
char LCDBuf[50];//oled
uint32_t AS608Addr = 0XFFFFFFFF;//Ĭ

char str2[6] = {0};

uint8_t USART3_RX_BUF[USART3_MAX_RECV_LEN]; 				//ջ,USART3_MAX_RECV_LENֽ.

uint8_t Get_Device_Code[10] ={0x01,0x00,0x07,0x13,0x00,0x00,0x00,0x00,0x00,0x1b};//֤

uint8_t USART3_RX_STA= 0;//Ƿյ

SearchResult seach;

//ڷһֽ
static uint8_t MYUSART_SendData(uint8_t data)
{
	if(HAL_UART_Transmit(&AS608_UART,&data,1,0xff) == HAL_OK)
		return 0;
	return 1;
}
//Ͱͷ
static void SendHead(void)
{
	memset(USART3_RX_BUF,0,sizeof(USART3_RX_BUF));//ǰݣΪжҪͰͷֻҪڷͰͷǰռ
  MYUSART_SendData(0xEF);
  MYUSART_SendData(0x01);
}
//͵ַ
static void SendAddr(void)
{
  MYUSART_SendData(AS608Addr >> 24);
  MYUSART_SendData(AS608Addr >> 16);
  MYUSART_SendData(AS608Addr >> 8);
  MYUSART_SendData(AS608Addr);
}
//Ͱʶ,
static void SendFlag(uint8_t flag)
{
  MYUSART_SendData(flag);
}
//Ͱ
static void SendLength(int length)
{
  MYUSART_SendData(length >> 8);
  MYUSART_SendData(length);
}
//ָ
static void Sendcmd(uint8_t cmd)
{
  MYUSART_SendData(cmd);
}
//У
static void SendCheck(uint16_t check)
{
  MYUSART_SendData(check >> 8);
  MYUSART_SendData(check);
}

/*****************************************
uint8_t AS608_Check(void)

ģǷӼ 
ֵģ˷0 򷵻1
*****************************************/
static uint8_t AS608_Check(void)
{
	USART3_RX_BUF[9] = 1;
	
  SendHead();
  SendAddr();
	for(int i = 0; i < 10; i++)
	{
		MYUSART_SendData(Get_Device_Code[i]);
	}
	//HAL_UART_Receive(&AS608_UART,USART3_RX_BUF,12,100);//12
	HAL_Delay(200);//ȴ200ms
	if(USART3_RX_BUF[9] == 0)
		return 0;

  return 1;
}
/*ָģʼ*/
uint8_t as608_init(void)
{
	//uart3ж
	HAL_UART_Receive_IT(&AS608_UART,USART3_RX_BUF,sizeof( USART3_RX_BUF));//ݣҲж
	//ʹܿж
	__HAL_UART_ENABLE_IT(&AS608_UART,UART_IT_IDLE);//
	
	return AS608_Check();
}
//жжϽյûӦ
//waittimeΪȴжϽݵʱ䣨λ1ms
//ֵݰ׵ַ
static uint8_t *JudgeStr(uint16_t waittime)
{
  char *data;
  uint8_t str[8];
  str[0] = 0xef;
  str[1] = 0x01;
  str[2] = AS608Addr >> 24;
  str[3] = AS608Addr >> 16;
  str[4] = AS608Addr >> 8;
  str[5] = AS608Addr;
  str[6] = 0x07;
  str[7] = '\0';
  USART3_RX_STA = 0;
  while(--waittime)
  {
    HAL_Delay(1);
    if(USART3_RX_STA) //յһ
    {
      USART3_RX_STA = 0;
      data = strstr((const char*)USART3_RX_BUF, (const char*)str);
      if(data)
        return (uint8_t*)data;
    }
  }
  return 0;
}
//¼ͼ PS_GetImage
//:ָ̽̽⵽¼ָͼImageBuffer
//ģ鷵ȷ
uint8_t PS_GetImage(void)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x03);
  Sendcmd(0x01);
  temp =  0x01 + 0x03 + 0x01;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
    ensure = data[9];
  else
    ensure = 0xff;
  return ensure;
}
// PS_GenChar
//:ImageBufferеԭʼͼָļCharBuffer1CharBuffer2
//:BufferID --> charBuffer1:0x01	charBuffer1:0x02
//ģ鷵ȷ
uint8_t PS_GenChar(uint8_t BufferID)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x04);
  Sendcmd(0x02);
  MYUSART_SendData(BufferID);
  temp = 0x01 + 0x04 + 0x02 + BufferID;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
    ensure = data[9];
  else
    ensure = 0xff;
  return ensure;
}
//ȷȶöָ PS_Match
//:ȷȶCharBuffer1 CharBuffer2 еļ
//ģ鷵ȷ
uint8_t PS_Match(void)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x03);
  Sendcmd(0x03);
  temp = 0x01 + 0x03 + 0x03;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
    ensure = data[9];
  else
    ensure = 0xff;
  return ensure;
}
//ָ PS_Search
//:CharBuffer1CharBuffer2еļ򲿷ָƿ.򷵻ҳ롣
//:  BufferID @ref CharBuffer1	CharBuffer2
//˵:  ģ鷵ȷ֣ҳ루ָģ壩
uint8_t PS_Search(uint8_t BufferID, uint16_t StartPage, uint16_t PageNum, SearchResult *p)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x08);
  Sendcmd(0x04);
  MYUSART_SendData(BufferID);
  MYUSART_SendData(StartPage >> 8);
  MYUSART_SendData(StartPage);
  MYUSART_SendData(PageNum >> 8);
  MYUSART_SendData(PageNum);
  temp = 0x01 + 0x08 + 0x04 + BufferID
         + (StartPage >> 8) + (uint8_t)StartPage
         + (PageNum >> 8) + (uint8_t)PageNum;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
  {
    ensure = data[9];
    p->pageID   = (data[10] << 8) + data[11];
    p->mathscore = (data[12] << 8) + data[13];
  }
  else
    ensure = 0xff;
  return ensure;
}
//ϲģ壩PS_RegModel
//:CharBuffer1CharBuffer2еļϲ ģ,CharBuffer1CharBuffer2
//˵:  ģ鷵ȷ
uint8_t PS_RegModel(void)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x03);
  Sendcmd(0x05);
  temp = 0x01 + 0x03 + 0x05;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
    ensure = data[9];
  else
    ensure = 0xff;
  return ensure;
}
//ģ PS_StoreChar
//: CharBuffer1  CharBuffer2 еģļ浽 PageID flashݿλá
//:  BufferID @ref charBuffer1:0x01	charBuffer1:0x02
//       PageIDָƿλúţ
//˵:  ģ鷵ȷ
uint8_t PS_StoreChar(uint8_t BufferID, uint16_t PageID)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x06);
  Sendcmd(0x06);
  MYUSART_SendData(BufferID);
  MYUSART_SendData(PageID >> 8);
  MYUSART_SendData(PageID);
  temp = 0x01 + 0x06 + 0x06 + BufferID
         + (PageID >> 8) + (uint8_t)PageID;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
    ensure = data[9];
  else
    ensure = 0xff;
  return ensure;
}
//ɾģ PS_DeletChar
//:  ɾflashݿָIDſʼNָģ
//:  PageID(ָƿģ)Nɾģ
//˵:  ģ鷵ȷ
uint8_t PS_DeletChar(uint16_t PageID, uint16_t N)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x07);
  Sendcmd(0x0C);
  MYUSART_SendData(PageID >> 8);
  MYUSART_SendData(PageID);
  MYUSART_SendData(N >> 8);
  MYUSART_SendData(N);
  temp = 0x01 + 0x07 + 0x0C
         + (PageID >> 8) + (uint8_t)PageID
         + (N >> 8) + (uint8_t)N;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
    ensure = data[9];
  else
    ensure = 0xff;
  return ensure;
}
//ָƿ PS_Empty
//:  ɾflashݿָģ
//:  
//˵:  ģ鷵ȷ
uint8_t PS_Empty(void)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x03);
  Sendcmd(0x0D);
  temp = 0x01 + 0x03 + 0x0D;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
    ensure = data[9];
  else
    ensure = 0xff;
  return ensure;
}
//дϵͳĴ PS_WriteReg
//:  дģĴ
//:  ĴRegNum:4\5\6
//˵:  ģ鷵ȷ
uint8_t PS_WriteReg(uint8_t RegNum, uint8_t DATA)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x05);
  Sendcmd(0x0E);
  MYUSART_SendData(RegNum);
  MYUSART_SendData(DATA);
  temp = RegNum + DATA + 0x01 + 0x05 + 0x0E;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
    ensure = data[9];
  else
    ensure = 0xff;
  if(ensure == 0)
    printf("\r\nòɹ");
  else
    printf("\r\n%s", EnsureMessage(ensure));
  return ensure;
}
//ϵͳ PS_ReadSysPara
//:  ȡģĻʣС)
//:  
//˵:  ģ鷵ȷ + 16bytes
uint8_t PS_ReadSysPara(SysPara *p)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x03);
  Sendcmd(0x0F);
  temp = 0x01 + 0x03 + 0x0F;
  SendCheck(temp);
  data = JudgeStr(1000);
  if(data)
  {
    ensure = data[9];
    p->PS_max = (data[14] << 8) + data[15];
    p->PS_level = data[17];
    p->PS_addr = (data[18] << 24) + (data[19] << 16) + (data[20] << 8) + data[21];
    p->PS_size = data[23];
    p->PS_N = data[25];
  }
  else
    ensure = 0xff;
  if(ensure == 0x00)
  {
    printf("\r\nģָ=%d", p->PS_max);
    printf("\r\nԱȵȼ=%d", p->PS_level);
    printf("\r\nַ=%x", p->PS_addr);
    printf("\r\n=%d", p->PS_N * 9600);
  }
  else
    printf("\r\n%s", EnsureMessage(ensure));
  return ensure;
}
//ģַ PS_SetAddr
//:  ģַ
//:  PS_addr
//˵:  ģ鷵ȷ
uint8_t PS_SetAddr(uint32_t PS_addr)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x07);
  Sendcmd(0x15);
  MYUSART_SendData(PS_addr >> 24);
  MYUSART_SendData(PS_addr >> 16);
  MYUSART_SendData(PS_addr >> 8);
  MYUSART_SendData(PS_addr);
  temp = 0x01 + 0x07 + 0x15
         + (uint8_t)(PS_addr >> 24) + (uint8_t)(PS_addr >> 16)
         + (uint8_t)(PS_addr >> 8) + (uint8_t)PS_addr;
  SendCheck(temp);
  AS608Addr = PS_addr; //ָַ
  data = JudgeStr(2000);
  if(data)
    ensure = data[9];
  else
    ensure = 0xff;
  AS608Addr = PS_addr;
  if(ensure == 0x00)
    printf("\r\nõַɹ");
  else
    printf("\r\n%s", EnsureMessage(ensure));
  return ensure;
}
//ܣ ģڲΪû256bytesFLASHռڴû±,
//	ü±߼ϱֳ 16 ҳ
//:  NotePageNum(0~15),Byte32(Ҫдݣ32ֽ)
//˵:  ģ鷵ȷ
uint8_t PS_WriteNotepad(uint8_t NotePageNum, uint8_t *Byte32)
{
  uint16_t temp;
  uint8_t  ensure, i;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(36);
  Sendcmd(0x18);
  MYUSART_SendData(NotePageNum);
  for(i = 0; i < 32; i++)
  {
    MYUSART_SendData(Byte32[i]);
    temp += Byte32[i];
  }
  temp = 0x01 + 36 + 0x18 + NotePageNum + temp;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
    ensure = data[9];
  else
    ensure = 0xff;
  return ensure;
}
//PS_ReadNotepad
//ܣ  ȡFLASHû128bytes
//:  NotePageNum(0~15)
//˵:  ģ鷵ȷ+ûϢ
uint8_t PS_ReadNotepad(uint8_t NotePageNum, uint8_t *Byte32)
{
  uint16_t temp;
  uint8_t  ensure, i;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x04);
  Sendcmd(0x19);
  MYUSART_SendData(NotePageNum);
  temp = 0x01 + 0x04 + 0x19 + NotePageNum;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
  {
    ensure = data[9];
    for(i = 0; i < 32; i++)
    {
      Byte32[i] = data[10 + i];
    }
  }
  else
    ensure = 0xff;
  return ensure;
}
//PS_HighSpeedSearch
//ܣ CharBuffer1CharBuffer2еļ򲿷ָƿ⡣
//		  򷵻ҳ,ָڵȷָƿ ҵ¼ʱ
//		  ܺõָƣܿ
//:  BufferID StartPage(ʼҳ)PageNumҳ
//˵:  ģ鷵ȷ+ҳ루ָģ壩
uint8_t PS_HighSpeedSearch(uint8_t BufferID, uint16_t StartPage, uint16_t PageNum, SearchResult *p)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x08);
  Sendcmd(0x1b);
  MYUSART_SendData(BufferID);
  MYUSART_SendData(StartPage >> 8);
  MYUSART_SendData(StartPage);
  MYUSART_SendData(PageNum >> 8);
  MYUSART_SendData(PageNum);
  temp = 0x01 + 0x08 + 0x1b + BufferID
         + (StartPage >> 8) + (uint8_t)StartPage
         + (PageNum >> 8) + (uint8_t)PageNum;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
  {
    ensure = data[9];
    p->pageID 	= (data[10] << 8) + data[11];
    p->mathscore = (data[12] << 8) + data[13];
  }
  else
    ensure = 0xff;
  return ensure;
}
//Чģ PS_ValidTempleteNum
//ܣЧģ
//: 
//˵: ģ鷵ȷ+ЧģValidN
uint8_t PS_ValidTempleteNum(uint16_t *ValidN)
{
  uint16_t temp;
  uint8_t  ensure;
  uint8_t  *data;
  SendHead();
  SendAddr();
  SendFlag(0x01);//ʶ
  SendLength(0x03);
  Sendcmd(0x1d);
  temp = 0x01 + 0x03 + 0x1d;
  SendCheck(temp);
  data = JudgeStr(2000);
  if(data)
  {
    ensure = data[9];
    *ValidN = (data[10] << 8) + data[11];
  }
  else
    ensure = 0xff;

  if(ensure == 0x00)
  {
    printf("\r\nЧָƸ=%d", (data[10] << 8) + data[11]);
  }
  else
    printf("\r\n%s", EnsureMessage(ensure));
  return ensure;
}
//AS608 PS_HandShake
//: PS_Addrַָ
//˵: ģ鷵µַȷַ
uint8_t PS_HandShake(uint32_t *PS_Addr)
{
  SendHead();
  SendAddr();
  MYUSART_SendData(0X01);
  MYUSART_SendData(0X00);
  MYUSART_SendData(0X00);
  HAL_Delay(200);
  if(USART3_RX_STA & 0X8000) //յ
  {
    if(//жǲģ鷵صӦ
      USART3_RX_BUF[0] == 0XEF
      && USART3_RX_BUF[1] == 0X01
      && USART3_RX_BUF[6] == 0X07
    )
    {
      *PS_Addr = (USART3_RX_BUF[2] << 24) + (USART3_RX_BUF[3] << 16)
                 + (USART3_RX_BUF[4] << 8) + (USART3_RX_BUF[5]);
      USART3_RX_STA = 0;
      return 0;
    }
    USART3_RX_STA = 0;
  }
  return 1;
}
//ģӦȷϢ
//ܣȷϢϢ
//: ensure
const char *EnsureMessage(uint8_t ensure)
{
  const char *p;
  switch(ensure)
  {
  case  0x00:
    p = "       OK       ";
    break;
  case  0x01:
    p = " ݰմ ";
    break;
  case  0x02:
    p = "ûָ";
    break;
  case  0x03:
    p = "¼ָͼʧ";
    break;
  case  0x04:
    p = " ָ̫ɻ̫ ";
    break;
  case  0x05:
    p = " ָ̫ʪ̫ ";
    break;
  case  0x06:
    p = "  ָͼ̫  ";
    break;
  case  0x07:
    p = " ָ̫ ";
    break;
  case  0x08:
    p = "  ָƲƥ    ";
    break;
  case  0x09:
    p = " ûָ ";
    break;
  case  0x0a:
    p = "   ϲʧ ";
    break;
  case  0x0b:
    p = "ַųΧ";
  case  0x10:
    p = "  ɾģʧ  ";
    break;
  case  0x11:
    p = " ָƿʧ ";
    break;
  case  0x15:
    p = "Чͼ";
    break;
  case  0x18:
    p = " дFLASH  ";
    break;
  case  0x19:
    p = "   δ   ";
    break;
  case  0x1a:
    p = "  ЧĴ  ";
    break;
  case  0x1b:
    p = " Ĵݴ ";
    break;
  case  0x1c:
    p = " ±ҳ ";
    break;
  case  0x1f:
    p = "    ָƿ    ";
    break;
  case  0x20:
    p = "    ַ    ";
    break;
  default :
    p = " ȷ ";
    break;
  }
  return p;
}

//ʾȷϢ
void ShowErrMessage(uint8_t ensure)
{
  //OLED_ShowCH(5,0,(uint8_t*)EnsureMessage(ensure));
	printf("%s\r\n",EnsureMessage(ensure));
}


//¼ָ
void Add_FR(void)
{
  uint8_t i, ensure ;
	
    switch (processnum)
    {
    case 0:
      i++;
			lv_obj_set_style_text_color(guider_ui.screen7_label_17, lv_color_hex(0xFF3300), 0);
	    lv_label_set_text(guider_ui.screen7_label_17, "press");
		  SYN_FrameInfo(2, "[v10][m0][t5]밴ָ");
	   	HAL_Delay(2000);
			//printf("밴ָ\r\n");
      ensure = PS_GetImage();
      if(ensure == 0x00)
      {
        ensure = PS_GenChar(CharBuffer1); //
        if(ensure == 0x00)
        {
			 lv_obj_set_style_text_color(guider_ui.screen7_label_17, lv_color_hex(0xFF3300), 0);
	     lv_label_set_text(guider_ui.screen7_label_17, "normal");
					//printf("ָ\r\n");
          i = 0;
          processnum = 1; //ڶ
        }
        else ShowErrMessage(ensure);
      }
      else ShowErrMessage(ensure);
      break;

    case 1:
      i++;
		lv_obj_set_style_text_color(guider_ui.screen7_label_17, lv_color_hex(0xFF3300), 0);
	  lv_label_set_text(guider_ui.screen7_label_17, "again");
		 // printf("ٰһ\r\n");
      ensure = PS_GetImage();
      if(ensure == 0x00)
      {
        ensure = PS_GenChar(CharBuffer2); //
        if(ensure == 0x00)
        {
				lv_obj_set_style_text_color(guider_ui.screen7_label_17, lv_color_hex(0xFF3300), 0);
	     lv_label_set_text(guider_ui.screen7_label_17, "normal");
          i = 0;
          processnum = 2; //
        }
        else ShowErrMessage(ensure);
      }
      else ShowErrMessage(ensure);
      break;

    case 2:
		  //printf("Աָ\r\n");
      ensure = PS_Match();
      if(ensure == 0x00)
      {

			//	printf("Աȳɹ\r\n");
        processnum = 3; //Ĳ
      }
      else
      {
			
				//printf("Աʧ\r\n");
        ShowErrMessage(ensure);
        i = 0;
        processnum = 0; //صһ
      }
      HAL_Delay(500);
      break;

    case 3:
		  //printf("ָģ\r\n");
      HAL_Delay(500);
      ensure = PS_RegModel();
      if(ensure == 0x00)
      {
			//	printf("ָģɹ\r\n");
        processnum = 4; //岽
      }
      else
      {
        processnum = 0;
        ShowErrMessage(ensure);
      }
      HAL_Delay(1000);
      break;

    case 4:
			printf("ĬѡIDΪ%d \r\n",ID_NUMBER);
	//	ID_NUM = 1;
		#if 0
      while(key_num != 3)
      {
        key_num = KEY_Scan(0);
        if(key_num == 2)
        {
          key_num = 0;
          if(ID_NUM > 0)
            ID_NUM--;
        }
        if(key_num == 4)
        {
          key_num = 0;
          if(ID_NUM < 99)
            ID_NUM++;
        }
        OLED_ShowCH(40, 6, "ID=");
        OLED_ShowNum(65, 6, ID_NUM, 2, 1);
      }
		
      key_num = 0;
			#endif
      ensure = PS_StoreChar(CharBuffer2, ID_NUMBER); //ģ
      if(ensure == 0x00)
      {
				lv_obj_set_style_text_color(guider_ui.screen7_label_17, lv_color_hex(0x33FF33), 0);
	      lv_label_set_text(guider_ui.screen7_label_17, "success");
				printf("¼ָƳɹ\r\n");
				beep_one(200);
				SYN_FrameInfo(2, "[v10][m0][t5]ɹ");
        HAL_Delay(5000);
				processnum=0;
        as608_cotrol=0;//ɹ֮˳
        return ;
      }
      else
      {
				lv_obj_set_style_text_color(guider_ui.screen7_label_17, lv_color_hex(0xFF3300), 0);
	     lv_label_set_text(guider_ui.screen7_label_17, "fail");
				SYN_FrameInfo(2, "[v10][m0][t5]ʧ");
        processnum = 0;
        ShowErrMessage(ensure);
      }
      break;
    }
    HAL_Delay(400);

}

SysPara AS608Para;//ָģAS608
//ˢָ
void press_FR(void)
{
  
  uint8_t ensure;
//  char str[20];
 
    ensure = PS_GetImage();
    if(ensure == 0x00) //ȡͼɹ
    {
      ensure = PS_GenChar(CharBuffer1);
      if(ensure == 0x00) //ɹ
      {
        ensure = PS_HighSpeedSearch(CharBuffer1, 0, 99, &seach);
        if(ensure == 0x00) //ɹ
        {
					press_FR_data=1;

					printf("ָ֤ɹ");
          //sprintf(str, " ID:%d ÷:%d ", seach.pageID, seach.mathscore);
					//printf("%s\r\n",str);
	          beep_one(200);
					  HAL_Delay(1000);
        }
        else
        {
					press_FR_data=0;

					printf("֤ʧ\r\n");
					HAL_Delay(1000);
        }
      }
      else
			{};
			printf("밴ָ\r\n");
    }
}

//ɾָ
void Del_FR(void)
{
  uint8_t  ensure;
  //uint16_t ID_NUM = 0;
	printf("ɾָƿʼĬɾIDΪ1");
	//ID_NUM = 1;
  ensure = PS_DeletChar(ID_NUMBER, 1); //ɾָ
  if(ensure == 0)
  {
		printf("ɾָƳɹ \r\n");
  }
  else
    ShowErrMessage(ensure);
    HAL_Delay(1500);

}
/*ָƿ*/
void Del_FR_Lib(void)
{
	uint8_t  ensure;
	printf("ɾָƿ⿪ʼ\r\n");
  ensure = PS_Empty(); //ָƿ
  if(ensure == 0)
  {
		printf("ָƿɹ\r\n");
  }
  else
     ShowErrMessage(ensure);
  HAL_Delay(1500);
}
