#include "lcd.h"
#include "cfont.h"
#include "GPIO.h"
#include "stm32f4xx_hal.h"

/*********************************************************************************
********************** STM32F407Ӧÿ()************************
**********************************************************************************
* ļ: lcd.c                                                                *
* ļLCDʾ                                                      *
* ڣ2016.10.08                                                           *
*     V1.0                                                                 *
*     ߣClever                                                               *
* ˵    ֧ĻΪILI9341SSD1963                                 * 
*           RA8875ģRA8875ĻеLCDļ滻̵  *
            LCDļУ±뼴                                              *
**********************************************************************************
*********************************************************************************/	 

  

//ʼLCDĻɫͱɫ	   
u16 BRUSH_COLOR=BLACK;	//ɫ
u16 BACK_COLOR=WHITE;   //ɫ 

//LCD
u16  lcd_id;          //LCD ID
u8   dir_flag;        //ƣ01
u16  lcd_width;       //LCDĿ
u16  lcd_height;      //LCDĸ߶
u16	 write_gramcmd;		//дgramָ
u16  setxcmd;		      //xָ
u16  setycmd;		      //yָ	

/****************************************************************************
*     : void LCD_WriteReg(u16 LCD_Reg, u16 LCD_Value)
*     ܣLCDдĴ
* ڲLCD_Reg: Ĵַ
*           LCD_RegValue: Ҫд
* ز
* ˵           
****************************************************************************/				   
void LCD_WriteReg(u16 LCD_Reg, u16 LCD_Value)
{	
	LCD_CMD = LCD_Reg;		 //дҪдļĴ	 
	LCD_DATA = LCD_Value;  //Ĵд	    		 
}

/****************************************************************************
*     : u16 LCD_ReadReg(u16 LCD_Reg)
*     ܣLCDĴ
* ڲLCD_Reg:Ĵַ
* زüĴֵ
* ˵           
****************************************************************************/	
u16 LCD_ReadReg(u16 LCD_Reg)
{										   
	LCD_CMD=LCD_Reg;		//дҪļĴ
	//delay_us(4);	
  HAL_Delay(1);	
	return LCD_DATA;		//ضֵ
} 

//lcdʱ
void lcdm_delay(u8 i)
{
	while(i--);
}

//ʼдGRAM
void LCD_WriteGRAM(void)
{
 	LCD_CMD=write_gramcmd;	  
}

//LCDʾ
void LCD_DisplayOn(void)
{					   
   LCD_CMD=0x29;   //93411963ʾһ
}	

//LCDرʾ
void LCD_DisplayOff(void)
{	
	 LCD_CMD=0x28;   //93411963ʾһ
} 
 
/****************************************************************************
*     : void LCD_Open_Window(u16 X0,u16 Y0,u16 width,u16 height)
*     ܣ,û굽Ͻ(X0,Y0)
* ڲX0,Y0:ʼ(Ͻ)
            width,height:ڿȺ͸߶
* ز
* ˵    С:width*height.B
****************************************************************************/
void LCD_Open_Window(u16 X0,u16 Y0,u16 width,u16 height)
{   
	width=X0+width-1;    //½
	height=Y0+height-1;
  
	if(dir_flag==0&&lcd_id==0X1963)  //1963
		{
			X0=lcd_width-width-X0; 
			height=Y0+height-1; 
			LCD_CMD=setxcmd; 
			LCD_DATA=X0>>8; 
			LCD_DATA=X0&0XFF;	 
			LCD_DATA=(X0+width-1)>>8; 
			LCD_DATA=(X0+width-1)&0XFF;  
			LCD_CMD=setycmd; 
			LCD_DATA=Y0>>8; 
			LCD_DATA=Y0&0XFF; 
			LCD_DATA=height>>8; 
			LCD_DATA=height&0XFF; 		
		}
	else
		{
			LCD_CMD=setxcmd; 
			LCD_DATA=X0>>8; 
			LCD_DATA=X0&0XFF;	 
			LCD_DATA=width>>8; 
			LCD_DATA=width&0XFF;  
			LCD_CMD=setycmd; 
			LCD_DATA=Y0>>8; 
			LCD_DATA=Y0&0XFF; 
			LCD_DATA=height>>8; 
			LCD_DATA=height&0XFF; 
		}
} 

/****************************************************************************
*     : void Set_Scan_Direction(u8 direction)
*     ܣLCDɨ跽
* ڲdirectionɨ跽
* ز
* ˵         
****************************************************************************/  	   
void Set_Scan_Direction(u8 direction)
{
	u16 skhda=0;
	u16 diomf=0;
	    //93411963ʱҪת
	if( (dir_flag==1&&lcd_id==0X9341)||(dir_flag==0&&lcd_id==0X1963)) 
	  {			   
			switch(direction)//ת
				{
					case 0:direction=6;break;
					case 1:direction=7;break;
					case 2:direction=4;break;
					case 3:direction=5;break;
					case 4:direction=1;break;
					case 5:direction=0;break;
					case 6:direction=3;break;
					case 7:direction=2;break;	     
				}
    }	
		
		switch(direction)
		{
			case L2R_U2D:   //,ϵ
				skhda|=(0<<7)|(0<<6)|(0<<5); 
				break;
			case L2R_D2U:   //,µ
				skhda|=(1<<7)|(0<<6)|(0<<5); 
				break;
			case R2L_U2D:   //ҵ,ϵ
				skhda|=(0<<7)|(1<<6)|(0<<5); 
				break;
			case R2L_D2U:   //ҵ,µ
				skhda|=(1<<7)|(1<<6)|(0<<5); 
				break;	 
			case U2D_L2R:   //ϵ,
				skhda|=(0<<7)|(0<<6)|(1<<5); 
				break;
			case U2D_R2L:   //ϵ,ҵ
				skhda|=(0<<7)|(1<<6)|(1<<5); 
				break;
			case D2U_L2R:   //µ,
				skhda|=(1<<7)|(0<<6)|(1<<5); 
				break;
			case D2U_R2L:   //µ,ҵ
				skhda|=(1<<7)|(1<<6)|(1<<5); 
				break;	 
		}
	  diomf=0X36;
	  if(lcd_id==0X9341)		
			 skhda|=0X08;		
	  LCD_WriteReg(diomf,skhda);		
	  LCD_Open_Window(0,0,lcd_width,lcd_height);  //ɨ跽󣬿ʾΪȫ
}

/****************************************************************************
*     : void Set_Display_Mode(u8 mode)
*     ܣLCDʾ
* ڲmode: 0,
                  1,
* ز
* ˵    B
****************************************************************************/
void Set_Display_Mode(u8 mode)
{
	if(mode==0)		  //
	{
		dir_flag=0;	

    if(lcd_id==0X9341)
		{
			write_gramcmd=0X2C;
			setxcmd=0X2A;
			setycmd=0X2B; 
		  lcd_width=240;
		  lcd_height=320;					
		}	
		else if(lcd_id==0X1963)
		{
			write_gramcmd=0X2C;	 //GRAMָ 
			setxcmd=0X2B;	       //дXָ
		  setycmd=0X2A;	       //дYָ
			lcd_width=480;		   //ÿ480
			lcd_height=800;		   //ø߶800  
		}
	}
	else 				  //
	{	  				
    dir_flag=1;
		
		if(lcd_id==0X9341)
		{
			write_gramcmd=0X2C;
			setxcmd=0X2A;
			setycmd=0X2B; 
      lcd_width=320;
   		lcd_height=240;				
		}
		else if(lcd_id==0X1963)
		{
			write_gramcmd=0X2C;	  //GRAMָ 
			setxcmd=0X2A;	        //дXָ
			setycmd=0X2B;	        //дYָ
			lcd_width=800;		    //ÿ800
			lcd_height=480;		    //ø߶480  
		}			
	} 
	Set_Scan_Direction(L2R_U2D);	//ɨ跽   ,µ
}	

/****************************************************************************
*     : void LCD_SetCursor(u16 Xaddr, u16 Yaddr)
*     ܣùλ
* ڲxx
            yy
* ز
* ˵         
****************************************************************************/
void LCD_SetCursor(u16 Xaddr, u16 Yaddr)
{	 
	if(lcd_id==0X9341)
		{		    
			LCD_CMD=setxcmd; 
			LCD_DATA=(Xaddr>>8); 
			LCD_DATA=(Xaddr&0XFF);	 
			LCD_CMD=setycmd; 
			LCD_DATA=(Yaddr>>8); 
			LCD_DATA=(Yaddr&0XFF);
		}
	else if(lcd_id==0X1963)
		{  			 		
			if(dir_flag==0) 
			{
				Xaddr=lcd_width-1-Xaddr;
				LCD_CMD=setxcmd; 
				LCD_DATA=0;
				LCD_DATA=0; 		
				LCD_DATA=Xaddr>>8;
				LCD_DATA=Xaddr&0XFF;		 	 
			}else
			{
				LCD_CMD=setxcmd; 
				LCD_DATA=Xaddr>>8;
				LCD_DATA=Xaddr&0XFF; 		
				LCD_DATA=(lcd_width-1)>>8;
				LCD_DATA=(lcd_width-1)&0XFF;		 	 			
			}	
			LCD_CMD=setycmd; 
			LCD_DATA=Yaddr>>8;
			LCD_DATA=Yaddr&0XFF; 		
			LCD_DATA=(lcd_height-1)>>8;
			LCD_DATA=(lcd_height-1)&0XFF; 			 		
			
		}
} 

/****************************************************************************
*     : u16 LCD_GetPoint(u16 x,u16 y)
*     ܣȡĳɫֵ	
* ڲxx
            yy
* ز˵ɫ
* ˵         
****************************************************************************/
u16 LCD_GetPoint(u16 x,u16 y)
{
 	vu16 r=0,g=0,b=0;
   
	LCD_SetCursor(x,y);	
	
	LCD_CMD=0X2E;   //93411963GRAMָһ 
	r=LCD_DATA; 	
	
 	if(lcd_id==0X1963)
		 return r;		   //1963ֱӶ16λɫֵ
	
	else	 //9341
 	{
		 lcdm_delay(2);	  
		 b=LCD_DATA;    //9341Ҫ2
		 g=r&0XFF;		  //9341һζȡRGֵ,Rǰ,Gں,ռ8λ
		 g<<=8;
		 return (((r>>11)<<11)|((g>>10)<<5)|(b>>11)); //9341蹫ʽת
	} 		  	
}	

/****************************************************************************
*     : void LCD_DrawPoint(u16 x,u16 y)
*     ܣ㣨ڸõд뻭ʵɫ
* ڲxx
            yy
* ز
* ˵    BRUSH_COLOR:˵ɫֵ
****************************************************************************/
void LCD_DrawPoint(u16 x,u16 y)
{
	LCD_SetCursor(x,y);		    //ùλ 
	LCD_WriteGRAM();	        //ʼдGRAM
	LCD_DATA=BRUSH_COLOR; 
}

/****************************************************************************
*     : void LCD_Color_DrawPoint(u16 x,u16 y,u16 color)
*     ܣõ괦ӦɫڸõдԶɫ
* ڲxx
            yy
            color ˵ɫֵ
* ز
* ˵    color:д˵ɫֵ   GUIøú
****************************************************************************/
void LCD_Color_DrawPoint(u16 x,u16 y,u16 color)
{	       
	 LCD_DrawPoint(x,y);
	 LCD_CMD=write_gramcmd; 
	 LCD_DATA=color;  
}	

/****************************************************************************
*     : void Ssd1963_Set_BackLight(u8 BL_value)
*     ܣSSD1963 ñ 
* ڲBL_valueȴС  ȡֵ:0-255  255
* ز
* ˵         
****************************************************************************/
void Ssd1963_Set_BackLight(u8 BL_value)
{	
	LCD_CMD=0xBE;	 
	LCD_DATA=0x05;	 
	LCD_DATA=BL_value; 
	LCD_DATA=0x01;	 
	LCD_DATA=0xFF;	 
	LCD_DATA=0x00;	 
	LCD_DATA=0x00;	 
}

/****************************************************************************
*     : void LCD_Clear(u16 color)
*     ܣ
* ڲcolor: Ҫɫ
* ز
* ˵    B
****************************************************************************/
void LCD_Clear(u16 color)
{
	u32 i=0;      
	u32 pointnum=0;
	
	pointnum=lcd_width*lcd_height; 	 //õLCDܵ
	LCD_SetCursor(0x00,0x00);	       //ùλ 
	LCD_WriteGRAM();     		 //ʼдGRAM	 	  
	for(i=0;i<pointnum;i++)
	{
		LCD_DATA=color;	   
	}
}



//FSMC
void LCD_FSMC_Config()
{

}

u16 ILI9341_Read_id(void)
{
 	 u16 id;
	
	 LCD_CMD=0xD3;	//9341ID   
	 id=LCD_DATA;	 
	 id=LCD_DATA; 	//0x00
	 id=LCD_DATA;   //0x93								   
	 id<<=8;
	 id|=LCD_DATA;  //0x41 
	
	 return id;
}

u16 SSD1963_Read_id(void)
{
 	 u16 id;
	
	 LCD_CMD=(0xA1);   //1963ID  
	 id=LCD_DATA;
	 id=LCD_DATA;	//0x57
	 id<<=8;	 
	 id|=LCD_DATA;	//0x61	
	
	 return id;
}

//ʼlcd
void LCD_Init(void)
{ 

  lcd_id=ILI9341_Read_id(); //ȶĻǲ9341
	
	 if(lcd_id!=0x9341)		//9341ǲ1963	 
		{
      lcd_id=SSD1963_Read_id();
			if(lcd_id==0x5761)
				 lcd_id=0x1963;  //SSD1963ʵʶID0x5761,ΪֱۣΪ1963
		}

  if(lcd_id==0X9341) //,дʱΪ
	{	 							    
		FSMC_Bank1E->BWTR[6]&=~(0XF<<0); //ַʱ 	 
		FSMC_Bank1E->BWTR[6]&=~(0XF<<8); //ݱʱ
		FSMC_Bank1E->BWTR[6]|=3<<0;		   //ַʱΪ3HCLK =18ns  	 
		FSMC_Bank1E->BWTR[6]|=2<<8;    	 //ݱʱΪ6ns*3HCLK=18ns
	}

	if(lcd_id==0X9341)	//9341ʼ
	{	 
		LCD_CMD=0xCF;  
		LCD_DATA=0x00;
		LCD_DATA=0xC1; 
		LCD_DATA=0X30; 
		LCD_CMD=0xED;  
		LCD_DATA=0x64; 
		LCD_DATA=0x03; 
		LCD_DATA=0X12; 
		LCD_DATA=0X81; 
		LCD_CMD=0xE8;  
		LCD_DATA=0x85; 
		LCD_DATA=0x10; 
		LCD_DATA=0x7A; 
		LCD_CMD=0xCB;  
		LCD_DATA=0x39; 
		LCD_DATA=0x2C; 
		LCD_DATA=0x00; 
		LCD_DATA=0x34; 
		LCD_DATA=0x02; 
		LCD_CMD=0xF7;  
		LCD_DATA=0x20; 
		LCD_CMD=0xEA;  
		LCD_DATA=0x00; 
		LCD_DATA=0x00; 
		LCD_CMD=0xC0;    
		LCD_DATA=0x1B;    
		LCD_CMD=0xC1;    
		LCD_DATA=0x01;    
		LCD_CMD=0xC5;     
		LCD_DATA=0x30; 	  
		LCD_DATA=0x30; 	  
		LCD_CMD=0xC7;      
		LCD_DATA=0XB7; 
		LCD_CMD=0x36;      
		LCD_DATA=0x48; 
		LCD_CMD=0x3A;   
		LCD_DATA=0x55; 
		LCD_CMD=0xB1;   
		LCD_DATA=0x00;   
		LCD_DATA=0x1A; 
		LCD_CMD=0xB6;     
		LCD_DATA=0x0A; 
		LCD_DATA=0xA2; 
		LCD_CMD=0xF2;      
		LCD_DATA=0x00; 
		LCD_CMD=0x26;      
		LCD_DATA=0x01; 
		LCD_CMD=0xE0;      
		LCD_DATA=0x0F; 
		LCD_DATA=0x2A; 
		LCD_DATA=0x28; 
		LCD_DATA=0x08; 
		LCD_DATA=0x0E; 
		LCD_DATA=0x08; 
		LCD_DATA=0x54; 
		LCD_DATA=0XA9; 
		LCD_DATA=0x43; 
		LCD_DATA=0x0A; 
		LCD_DATA=0x0F; 
		LCD_DATA=0x00; 
		LCD_DATA=0x00; 
		LCD_DATA=0x00; 
		LCD_DATA=0x00; 		 
		LCD_CMD=0XE1;     
		LCD_DATA=0x00; 
		LCD_DATA=0x15; 
		LCD_DATA=0x17; 
		LCD_DATA=0x07; 
		LCD_DATA=0x11; 
		LCD_DATA=0x06; 
		LCD_DATA=0x2B; 
		LCD_DATA=0x56; 
		LCD_DATA=0x3C; 
		LCD_DATA=0x05; 
		LCD_DATA=0x10; 
		LCD_DATA=0x0F; 
		LCD_DATA=0x3F; 
		LCD_DATA=0x3F; 
		LCD_DATA=0x0F; 
		LCD_CMD=0x2B; 
		LCD_DATA=0x00;
		LCD_DATA=0x00;
		LCD_DATA=0x01;
		LCD_DATA=0x3f;
		LCD_CMD=0x2A; 
		LCD_DATA=0x00;
		LCD_DATA=0x00;
		LCD_DATA=0x00;
		LCD_DATA=0xef;	 
		LCD_CMD=0x11;  
		HAL_Delay(120);
		LCD_CMD=0x29; 
		HAL_GPIO_WritePin(LCD_BL_GPIO_Port,LCD_BL_Pin,GPIO_PIN_SET);
	//	LCD_BACK=1;	  //
	}
	else if(lcd_id==0X1963)
	{
		LCD_CMD=0xE2;		
		LCD_DATA=0x1D;		
		LCD_DATA=0x02;		
		LCD_DATA=0x04;		
	//	delay_us(100);
		HAL_Delay(1);
		
		LCD_CMD=0xE0;		
		LCD_DATA=0x01;		
		HAL_Delay(10);
		
		LCD_CMD=0xE0;		
		LCD_DATA=0x03;		
		HAL_Delay(12); 
		
		LCD_CMD=0x01;		//λ
		HAL_Delay(10);

		LCD_CMD=0xE6;		
		LCD_DATA=0x2F;
		LCD_DATA=0xFF;
		LCD_DATA=0xFF;

		LCD_CMD=0xB0;		  
		LCD_DATA=0x20;		 
		LCD_DATA=0x00;		
	
		LCD_DATA=(800-1)>>8; //LCDˮƽ
		LCD_DATA=800-1;		 
		LCD_DATA=(480-1)>>8; //LCDֱ
		LCD_DATA=480-1;		 
		LCD_DATA=0x00;		   //RGB 
		
		LCD_CMD=0xB4;	
		LCD_DATA=(800+46+210-1)>>8;
		LCD_DATA=800+46+210-1;
		LCD_DATA=46>>8;
		LCD_DATA=46;
		LCD_DATA=0;
		LCD_DATA=0x00;
		LCD_DATA=0x00;
		LCD_DATA=0x00;
		
		LCD_CMD=0xB6;		 
		LCD_DATA=(480+23+22-1)>>8;
		LCD_DATA=480+23+22-1;
		LCD_DATA=23>>8;
		LCD_DATA=23;
		LCD_DATA=21;
		LCD_DATA=0x00;
		LCD_DATA=0x00;
		
		LCD_CMD=0xF0;	 
		LCD_DATA=0x03;	//SSD1963MCUĽӿΪ16bit  

		LCD_CMD=0x29;	//ʾ
		LCD_CMD=0xD0;	//ԶƽDBC
		LCD_DATA=0x00;	
	
		LCD_CMD=0xBE;	  //PWM
		LCD_DATA=0x05;	//PWMƵ
		LCD_DATA=0xFE;	//PWMռձ
		LCD_DATA=0x01;	
		LCD_DATA=0x00;	
		LCD_DATA=0x00;	
		LCD_DATA=0x00;	
		
		LCD_CMD=0xB8;	 
		LCD_DATA=0x03;	 
		LCD_DATA=0x01;	 
		LCD_CMD=0xBA;
		LCD_DATA=0X01;	//LCD

		Ssd1963_Set_BackLight(255);//
	}
	Set_Display_Mode(1);		 //		
	LCD_Clear(WHITE);        //ɫ
} 

/****************************************************************************
*     : void LCD_Fill_onecolor(u16 sx,u16 sy,u16 ex,u16 ey,u16 color)
*     ܣָ䵥ɫ
* ڲ(sx,sy),(ex,ey):ζԽ
            color:Ҫɫ
* ز
* ˵    СΪ:(ex-sx+1)*(ey-sy+1)  B
****************************************************************************/
void LCD_Fill_onecolor(u16 sx,u16 sy,u16 ex,u16 ey,u16 color)
{  
        
	u16 i,j;
	u16 nlen=0;

		nlen=ex-sx+1;	 
		for(i=sy;i<=ey;i++)
		{
		 	LCD_SetCursor(sx,i);      				  //ùλ 
			LCD_WriteGRAM();     			  //ʼдGRAM	  
			for(j=0;j<nlen;j++)
			  LCD_DATA=color;	//ùλ 	    
		}
} 

/****************************************************************************
*     : void LCD_Draw_Picture(u16 sx,u16 sy,u16 ex,u16 ey,u16 *color)
*     ܣָڻͼƬ
* ڲ(sx,sy),(ex,ey):ζԽ
            color:ҪͼƬɫ
* ز
* ˵    СΪ:(ex-sx+1)*(ey-sy+1)  B
****************************************************************************/
void LCD_Draw_Picture(u16 sx,u16 sy,u16 ex,u16 ey,u16 *color)
{  
	u16 height,width;
	u16 i,j;
	width=ex-sx+1; 			    //õͼƬĿ
	height=ey-sy+1;			    //õͼƬĸ߶
 	for(i=0;i<height;i++)
	{
 		LCD_SetCursor(sx,sy+i); //ùλ 
		LCD_WriteGRAM();        //ʼдGRAM
		for(j=0;j<width;j++)
		   LCD_DATA=color[i*height+j];//дɫֵ
	}	  
}  
void LCD_Color_Fill(u16 sx, u16 sy, u16 ex, u16 ey, u16 *color)
{
    u16 height, width;
    u16 i, j;
    width = ex - sx + 1;            //õĿ
    height = ey - sy + 1;           //߶

    for (i = 0; i < height; i++)
    {
        LCD_SetCursor(sx, sy + i);  //ùλ
        LCD_WriteGRAM();        //ʼдGRAM

        for (j = 0; j < width; j++)
        {
            LCD_DATA=color[i * width + j];  //д
        }
    }
}
/****************************************************************************
*     : void LCD_DisplayChar(u16 x,u16 y,u8 num,u8 size)
*     ܣָλʾһַ
* ڲx,y:ʼ
            word:Ҫʾַ:abcdefg1234567890...
            size:С 12/16/24
* ز
* ˵    ģȡģΪȴңٴϵ  λǰ  B
****************************************************************************/
void LCD_DisplayChar(u16 x,u16 y,u8 word,u8 size)
{  							  
  u8  bytenum,bytedata, a,b;
	
	u16 xmid=x;   //洢ʼXֵ(λ)			     
	 
	if(size==12) bytenum=12;        //ֿп֪ÿ嵥ַռֽ
	else if(size==16) bytenum=16;
	else if(size==24) bytenum=48;
	else return;    //˳
	                
	word=word-' ';  //ֿǰASCII
  //cfont.hֿǴӿոʼ ոǵһԪ ַASCIIȥո͵õеƫֵ(λ) 
	    for(b=0;b<bytenum;b++)
	    {   
					if(size==12)bytedata=char_1206[word][b]; 	 	  //1206
					else if(size==16)bytedata=char_1608[word][b];	//1608
					else if(size==24)bytedata=char_2412[word][b];	//2412

					for(a=0;a<8;a++)   
					{	   
						if(bytedata&0x01) LCD_Color_DrawPoint(x,y,BRUSH_COLOR); //ģǵλǰ ȴӵλж  Ϊ1ʱʾɫ      
						else LCD_Color_DrawPoint(x,y,BACK_COLOR);               //0ʱʾɫ		
						bytedata>>=1;    //λж λж
						x++;	           //ʾһλ һλʾ 
						if((x-xmid)==size/2)  //x򳬳С 磺16 ʵ 08*16ĵ   size/2
						{
							x=xmid;  //ӳʼXλдһ
							y++;     //һд һд
							break;   //for(a=0;a<8;a++)ѭ
						}
		      }   	 
	    }       	 	  
}   

/****************************************************************************
*     : void LCD_DisplayString(u16 x,u16 y,u8 size,u8 *p)
*     ܣʾַ
* ڲx,y:
*           size:С
*           *p:ַʼַ	
* ز
* ˵      B
****************************************************************************/	  
void LCD_DisplayString(u16 x,u16 y,u8 size,u8 *p)
{         
    while((*p>=' ')&&(*p<='~')) //ֻʾ ~ַ֮
    {       
        LCD_DisplayChar(x,y,*p,size);
        x+=size/2;
			  if(x>=lcd_width) break;
        p++;
    }  
}

/****************************************************************************
*     : void LCD_DisplayString(u16 x,u16 y,u8 size,u8 *p)
*     ܣʾԶַ
* ڲx,y:
*           width,height:С  
*           size:С
*           *p:ַʼַ	
*           brushcolorԶ廭ɫ
*           backcolor Զ屳ɫ
* ز
* ˵      B
****************************************************************************/	  
void LCD_DisplayString_color(u16 x,u16 y,u8 size,u8 *p,u16 brushcolor,u16 backcolor)
{
   u16 bh_color,bk_color;
	
 	bh_color=BRUSH_COLOR;  //ݴ滭ɫ
	bk_color=BACK_COLOR;   //ݴ汳ɫ
	
	BRUSH_COLOR=brushcolor;
	BACK_COLOR=backcolor;
	
	LCD_DisplayString(x,y,size,p);
	
	BRUSH_COLOR=bh_color;   //ıϵͳɫ
	BACK_COLOR=bk_color;
}

//a^nֵ:a^nη
u32 Counter_Power(u8 a,u8 n)
{
	u32 mid=1;	 
	while(n--)mid*=a;    
	return mid;
}

/****************************************************************************
*     : void LCD_DisplayNum(u16 x,u16 y,u32 num,u8 len,u8 size,u8 mode)
*     ܣָλʾһ
* ڲx,y:
            value:ֵ;	 
            len:(ʾλ)
            size:С
            mode: 0λΪ0ʾ
                  1λΪ0lenȲʾ0
* ز
* ˵      B
****************************************************************************/
void LCD_DisplayNum(u16 x,u16 y,u32 value,u8 len,u8 size,u8 mode)
{  
	u8 t,numtemp;
	u8 value_num;     //ֵܹλ
  u32 value_mid;     
	
	value_mid=value;   //λʱӰҪʾֵС
	for (value_num = 0; value_mid > 0; value_num++)
  {
    value_mid /= 10;  
  } //ִfor֪ҪʾֵΪλ

	if(value_num>len)  //ֵλλʾ򲻹 ʾ
	{
	 LCD_DisplayString(x,y,size,"ERROR");
	 return; //˳
	}
	else
	{
	  for(t=0;t<len;t++)
		{
		  if( t<(len-value_num))
			{
			  if(mode)LCD_DisplayChar(x+(size/2)*t,y,'0',size);  
				else LCD_DisplayChar(x+(size/2)*t,y,' ',size);  
			}
			else
			{
			  numtemp=(value/Counter_Power(10,len-t-1))%10;  //ȡλֵ
			  LCD_DisplayChar(x+(size/2)*t,y,numtemp+'0',size); 
			}		
		}
	}
} 

/****************************************************************************
*     : void LCD_DisplayNum_color(u16 x,u16 y,u32 num,u8 len,u8 size,u8 mode)
*     ܣָλʾһԶɫ
* ڲx,y:
            num:ֵ;	 
            len:(Ҫʾλ)
            size:С
            mode: 0λΪ0ʾ
                  1λΪ0ʾ0
            brushcolorԶ廭ɫ
            backcolor Զ屳ɫ
* ز
* ˵      B
****************************************************************************/
void LCD_DisplayNum_color(u16 x,u16 y,u32 num,u8 len,u8 size,u8 mode,u16 brushcolor,u16 backcolor)
{
 u16 bh_color,bk_color;
	
 	bh_color=BRUSH_COLOR;  //ݴ滭ɫ
	bk_color=BACK_COLOR;   //ݴ汳ɫ
	
	BRUSH_COLOR=brushcolor;
	BACK_COLOR=backcolor;
	
	LCD_DisplayNum(x,y,num,len,size,mode);
	
	BRUSH_COLOR=bh_color;   //ıϵͳɫ
	BACK_COLOR=bk_color;
}

void Gui_DrawFont_GBK16(u16 x, u16 y, u16 fc, u16 bc, u8 *s)
{
	unsigned char i,j;
	unsigned short k,x0;
	x0=x;

	while(*s) 
	{	
		if((*s) < 128) 
		{
			k=*s;
			if (k==13) 
			{
				x=x0;
				y+=16;
			}
			else 
			{
				if (k>32) k-=32; else k=0;
	
			    for(i=0;i<16;i++)
				for(j=0;j<8;j++) 
					{
				    	if(asc16[k*16+i]&(0x80>>j))	LCD_Color_DrawPoint(x+j,y+i,fc);
						else 
						{
							if (fc!=bc) LCD_Color_DrawPoint(x+j,y+i,bc);
						}
					}
				x+=8;
			}
			s++;
		}
			
		else 
		{
		
			for (k=0;k<hz16_num;k++) //ֿҶӦַĴ
			{
			  if ((hz16[k].Index[0]==*(s))&&(hz16[k].Index[1]==*(s+1)))
			  { 
				    for(i=0;i<16;i++)
				    {
						for(j=0;j<8;j++) 
							{
						    	if(hz16[k].Msk[i*2]&(0x80>>j))	LCD_Color_DrawPoint(x+j,y+i,fc);
								else {
									if (fc!=bc) LCD_Color_DrawPoint(x+j,y+i,bc);
								}
							}
						for(j=0;j<8;j++) 
							{
						    	if(hz16[k].Msk[i*2+1]&(0x80>>j))	LCD_Color_DrawPoint(x+j+8,y+i,fc);
								else 
								{
									if (fc!=bc) LCD_Color_DrawPoint(x+j+8,y+i,bc);
								}
							}
				    }
				}
			  }
			s+=2;x+=16;
		} 
		
	}
}

//ʾ24x24ַ

void Gui_DrawFont_GBK24(u16 x, u16 y, u16 fc, u16 bc, u8 *s)
{
	unsigned char i,j;
	unsigned short k;

	while(*s) 
	{
		if( *s < 0x80 ) 
		{
		//	LCD_DisplayString_color(x,y,24,s,fc,bc);
			k=*s;
			if (k>32) k-=32; else k=0;

		    for(i=0;i<16;i++)
			for(j=0;j<8;j++) 
				{
			    if(asc16[k*16+i]&(0x80>>j))	
					LCD_Color_DrawPoint(x+j,y+i,fc);
					else 
					{
						if (fc!=bc) LCD_Color_DrawPoint(x+j,y+i,bc);
					}
				}
			s++;x+=8;
		}
		else 
		{

			for (k=0;k<hz24_num;k++) 
			{
			  if ((hz24[k].Index[0]==*(s))&&(hz24[k].Index[1]==*(s+1)))
			  { 
				    for(i=0;i<24;i++)
				    {
						for(j=0;j<8;j++) 
							{
						    	if(hz24[k].Msk[i*3]&(0x80>>j))
								LCD_Color_DrawPoint(x+j,y+i,fc);
								else 
								{
									if (fc!=bc) LCD_Color_DrawPoint(x+j,y+i,bc);
								}
							}
						for(j=0;j<8;j++) 
							{
						    	if(hz24[k].Msk[i*3+1]&(0x80>>j))	LCD_Color_DrawPoint(x+j+8,y+i,fc);
								else {
									if (fc!=bc) LCD_Color_DrawPoint(x+j+8,y+i,bc);
								}
							}
						for(j=0;j<8;j++) 
							{
						    	if(hz24[k].Msk[i*3+2]&(0x80>>j))	
								LCD_Color_DrawPoint(x+j+16,y+i,fc);
								else 
								{
									if (fc!=bc) LCD_Color_DrawPoint(x+j+16,y+i,bc);
								}
							}
				    }
			  }
			}
			s+=2;x+=24;
		}
	}
}

void ClearLine(u16 Line,u16 size,u16 color)
{
	
	u32 i=0;	
	LCD_SetCursor(0,Line);	       //ùλ 
	LCD_WriteGRAM();     		 //ʼдGRAM	 	  
	for(i=0;i<lcd_width*size;i++)
	{
		LCD_DATA=color;	   
	}

}
