#include "syn6288.h"
#include "main.h"
#include "usart.h"
#include <stdio.h>
#include <string.h>


/**************оƬ*********************/
uint8_t SYN_StopCom[] = {0xFD, 0X00, 0X02, 0X02, 0XFD}; //ֹͣϳ
uint8_t SYN_SuspendCom[] = {0XFD, 0X00, 0X02, 0X03, 0XFC}; //ͣϳ
uint8_t SYN_RecoverCom[] = {0XFD, 0X00, 0X02, 0X04, 0XFB}; //ָϳ
uint8_t SYN_ChackCom[] = {0XFD, 0X00, 0X02, 0X21, 0XDE}; //״̬ѯ
uint8_t SYN_PowerDownCom[] = {0XFD, 0X00, 0X02, 0X88, 0X77}; //POWER DOWN ״̬
/**************************************************************************************/
uint8_t buff[]={0,0,0,0,0};//յݰ



//Music:ѡ񱳾֡0:ޱ֣1~15ѡ񱳾
void SYN_FrameInfo(uint8_t Music, uint8_t *HZdata)
{
  /****************Ҫ͵ı**********************************/
  unsigned  char  Frame_Info[50];
  unsigned  char  HZ_Length;
  unsigned  char  ecc  = 0;  			//Уֽ
  unsigned  int i = 0;
  HZ_Length = strlen((char*)HZdata); 			//Ҫıĳ

  /*****************̶֡Ϣ**************************************/
  Frame_Info[0] = 0xFD ; 			//֡ͷFD
  Frame_Info[1] = 0x00 ; 			//ȵĸֽ
  Frame_Info[2] = HZ_Length + 3; 		//ȵĵֽ
  Frame_Info[3] = 0x01 ; 			//֣ϳɲ
  Frame_Info[4] = 0x01 | Music << 4 ; //趨

  /*******************У***************************************/
  for(i = 0; i < 5; i++)   				//η͹õ5֡ͷֽ
  {
    ecc = ecc ^ (Frame_Info[i]);		//Է͵ֽڽУ
  }

  for(i = 0; i < HZ_Length; i++)   		//ηʹϳɵı
  {
    ecc = ecc ^ (HZdata[i]); 				//Է͵ֽڽУ
  }
  /*******************֡Ϣ***************************************/
  memcpy(&Frame_Info[5], HZdata, HZ_Length);
  Frame_Info[5 + HZ_Length] = ecc;
 // USART3_SendString(Frame_Info, 5 + HZ_Length + 1);
	HAL_UART_Transmit(&huart4, (uint8_t *)Frame_Info,5 + HZ_Length + 1,0xffff);
}


/***********************************************************
*     ƣ YS_SYN_Set(u8 *Info_data)
*     ܣ 	
* ڲ *Info_data:̶Ϣ
* ڲ
* ˵    ãֹͣϳɡͣϳɵ Ĭϲ9600bps
* ÷ͨѾá
**********************************************************/
void YS_SYN_Set(uint8_t *Info_data)
{
  uint8_t Com_Len;
  Com_Len = strlen((char*)Info_data);
//  USART3_SendString(Info_data, Com_Len);
	HAL_UART_Transmit(&huart4, (uint8_t *)Info_data,Com_Len,0xffff);
}

/**************************************************************************************/








