//Ƭͷļ
#include "stm32f4xx.h"                  // Device header
#include "common.h"      

//豸
#include "esp8266.h"

//Ӳ

#include "usart.h"

//C
#include <string.h>
#include <stdio.h>


#define WIFI_SSID 						"hzxy"								//	WIFI 2.4Gwifi5GģҲġո
#define WIFI_PSWD 						"123456789"				//	WIFI

#define SERVER_HOST						"mqtt.mqttbai.xyz"			//	MQTTIP
#define SERVER_PORT						"1883"									//	MQTT˿ڣһΪ1883øģ


#define ESP8266_WIFI_INFO			"AT+CWJAP=\"" WIFI_SSID "\",\"" WIFI_PSWD "\"\r\n"
#define ESP8266_ONENET_INFO		"AT+CIPSTART=\"TCP\",\"" SERVER_HOST "\"," SERVER_PORT "\r\n"

unsigned char esp8266_buf[512];
unsigned short esp8266_cnt = 0, esp8266_cntPre = 0;

extern u8 ESP8266_INIT_OK;

uint8_t aRxBuffer1[1];		// մ1͵
uint8_t aRxBuffer2[1];		// մ2͵
uint8_t aRxBuffer6[1];		// մ6͵
u8 RX_num=0;   //ռ
u8  RX_buffer[tbuf];


//==========================================================
//	ƣ	ESP8266_Clear
//
//	ܣ	ջ
//
//	ڲ	
//
//	ز	
//
//	˵		
//==========================================================
void ESP8266_Clear(void)
{

	memset(esp8266_buf, 0, sizeof(esp8266_buf));
	esp8266_cnt = 0;

}

//==========================================================
//	ƣ	ESP8266_WaitRecive
//
//	ܣ	ȴ
//
//	ڲ	
//
//	ز	REV_OK-		REV_WAIT-ճʱδ
//
//	˵		ѭüǷ
//==========================================================
_Bool ESP8266_WaitRecive(void)
{

	if(esp8266_cnt == 0) 							//ռΪ0 ˵ûдڽУֱ
		return REV_WAIT;
		
	if(esp8266_cnt == esp8266_cntPre)				//һεֵͬ˵
	{
		esp8266_cnt = 0;							//0ռ
			
		return REV_OK;								//ؽɱ־
	}
		
	esp8266_cntPre = esp8266_cnt;					//Ϊͬ
	
	return REV_WAIT;								//ؽδɱ־

}

//==========================================================
//	ƣ	ESP8266_SendCmd
//
//	ܣ	
//
//	ڲ	cmd
//				resҪķָ
//
//	ز	0-ɹ	1-ʧ
//
//	˵		
//==========================================================
_Bool ESP8266_SendCmd(char *cmd, char *res)
{
	
	unsigned char timeOut = 200;
	HAL_UART_Transmit(&huart2,(unsigned char *)cmd,strlen((const char *)cmd),100);
	//HAL_UART_Transmit(&huart1,(unsigned char *)cmd,strlen((const char *)cmd),100);
	
	while(timeOut--)
	{
		if(ESP8266_WaitRecive() == REV_OK)							//յ
		{
			
			if(strstr((const char *)esp8266_buf, res) != NULL)		//ؼ
			{
				ESP8266_Clear();									//ջ
				
				return 0;
			}
		}
		
		HAL_Delay(10);
	}
	
	return 1;

}

//==========================================================
//	ƣ	ESP8266_SendData
//
//	ܣ	
//
//	ڲ	data
//				len
//
//	ز	
//
//	˵		
//==========================================================
void ESP8266_SendData(unsigned char *data, unsigned short len)
{

	char cmdBuf[32];
	
	ESP8266_Clear();								//սջ
	sprintf(cmdBuf, "AT+CIPSEND=%d\r\n", len);		//
	if(!ESP8266_SendCmd(cmdBuf, ">"))				//յ>ʱԷ
	{
		HAL_UART_Transmit(&huart2,data,len,100);		//豸
	}

}

//==========================================================
//	ƣ	ESP8266_GetIPD
//
//	ܣ	ȡƽ̨ص
//
//	ڲ	ȴʱ(10ms)
//
//	ز	ƽ̨صԭʼ
//
//	˵		ͬ豸صĸʽͬҪȥ
//				ESP8266ķظʽΪ	"+IPD,x:yyy"	xݳȣyyy
//==========================================================
unsigned char *ESP8266_GetIPD(unsigned short timeOut)
{

	char *ptrIPD = NULL;
	
	do
	{
		if(ESP8266_WaitRecive() == REV_OK)								//
		{
			ptrIPD = strstr((char *)esp8266_buf, "IPD,");				//IPDͷ
			if(ptrIPD == NULL)											//ûҵIPDͷӳ٣Ҫȴһᣬᳬ趨ʱ
			{
				printf("\"IPD\" not found\r\n");
			}
			else
			{
				ptrIPD = strchr(ptrIPD, ':');							//ҵ':'
				if(ptrIPD != NULL)
				{
					ptrIPD++;
					return (unsigned char *)(ptrIPD);
				}
				else
					return NULL;
				
			}
		}
		HAL_Delay(5);
		timeOut--;	//ʱȴ
	} while(timeOut > 0);
	
	return NULL;														//ʱδҵؿָ

}

//==========================================================
//	ƣ	ESP8266_Init
//
//	ܣ	ʼESP8266
//
//	ڲ	
//
//	ز	
//
//	˵		
//==========================================================
void ESP8266_Init(void)
{
	
  HAL_GPIO_WritePin(ESP8266_RST_GPIO_Port, ESP8266_RST_Pin, GPIO_PIN_RESET);
	HAL_Delay(250);
	HAL_GPIO_WritePin(ESP8266_RST_GPIO_Port, ESP8266_RST_Pin, GPIO_PIN_SET);
	HAL_Delay(500);
	
	ESP8266_Clear();
	
	printf("0. AT - MCU-8266ͨѶ\r\n");
	while(ESP8266_SendCmd("AT\r\n","OK"))
		HAL_Delay(500);
	
	printf("1. AT+RST - λ8266\r\n");
	ESP8266_SendCmd("AT+RST\r\n", "");
		HAL_Delay(500);
	ESP8266_SendCmd("AT+CIPCLOSE\r\n", "");
		HAL_Delay(500);
	printf("2. AT+CWMODE=1,1 - 8266ģʽΪSTA\r\n");
	while(ESP8266_SendCmd("AT+CWMODE=1\r\n", "OK"))
		HAL_Delay(500);
	
	printf("3. AT+CWDHCP=1,1 - ʹSTAģʽDHCP\r\n");
	while(ESP8266_SendCmd("AT+CWDHCP=1,1\r\n", "OK"))
		HAL_Delay(500);
	
	printf("4. AT+CWJAP - WIFI\r\n");
	while(ESP8266_SendCmd(ESP8266_WIFI_INFO, "GOT IP"))
		HAL_Delay(500);
	
	printf("5. AT+CIPSTART - ӷ\r\n");
	while(ESP8266_SendCmd(ESP8266_ONENET_INFO, "CONNECT"))
		HAL_Delay(500);
	ESP8266_INIT_OK = 1;
	printf("6. ESP8266 Init OK - ESP8266ʼɹ\r\n");
	printf("ESP8266ʼ			[OK]");
}

//==========================================================
//	ƣ	USART2_IRQHandler
//
//	ܣ	2շж
//
//	ڲ	
//
//	ز	
//
//	˵		
//==========================================================
//void USART2_IRQHandler(void)
//{
////printf("asd\n");
//	if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET) //ж
//	{
//		if(esp8266_cnt >= sizeof(esp8266_buf))	
//		{
//			esp8266_cnt = 0; //ֹڱˢ
//		}
//		esp8266_buf[esp8266_cnt++] = USART_ReceiveData(USART2);
//		//printf("%c\n",esp8266_buf[esp8266_cnt++]); 
//		USART_ClearFlag(USART2, USART_FLAG_RXNE);
//	}

//}


void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)//ڻص
{
	if(huart->Instance == USART1)	// жĸڴж
	{
		HAL_UART_Transmit(&huart1,aRxBuffer1,1,100);	// յʹô1ͳȥ
		//HAL_UART_Transmit(&huart6,aRxBuffer1,1,100);	// յʹô1ͳȥ
		HAL_UART_Receive_IT(&huart1,aRxBuffer1,1);		// ʹܴ1ж
	}	
	if(huart->Instance == USART2)	// жĸڴж
	{
		if(esp8266_cnt >= sizeof(esp8266_buf))	
		{
			esp8266_cnt = 0; //ֹڱˢ
		}
	  esp8266_buf[esp8266_cnt++] = aRxBuffer2[0];
		
		
		//HAL_UART_Transmit(&huart1,aRxBuffer2,1,100);	// յʹô1ͳȥ
		
		HAL_UART_Receive_IT(&huart2,aRxBuffer2,1);		// ʹܴ1ж
	}
	if(huart->Instance == USART6)	// жĸڴж
	{
		HAL_UART_Transmit(&huart1,aRxBuffer6,1,100);	// յʹô1ͳȥ
		HAL_UART_Receive_IT(&huart6,aRxBuffer6,1);		// ʹܴ1ж
	}
	
	
}

