#ifndef __AS608_H
#define __AS608_H

#include "stm32f4xx_hal.h"


#define CharBuffer1 0x01
#define CharBuffer2 0x02

#define USART3_MAX_RECV_LEN		400					//ջֽ

#define AS608_UART	huart3//AS608ģʹõĴ

extern uint8_t USART3_RX_BUF[USART3_MAX_RECV_LEN];

extern uint8_t USART3_RX_STA;

extern uint32_t AS608Addr;//ģַ

typedef struct  
{
	uint16_t pageID;//ָID
	uint16_t mathscore;//ƥ÷
}SearchResult;

typedef struct
{
	uint16_t PS_max;//ָ
	uint8_t  PS_level;//ȫȼ
	uint32_t PS_addr;
	uint8_t  PS_size;//ͨѶݰС
	uint8_t  PS_N;//ʻN
}SysPara;


uint8_t as608_init(void);
	
uint8_t PS_GetImage(void); //¼ͼ 
 
uint8_t PS_GenChar(uint8_t BufferID);// 

uint8_t PS_Match(void);//ȷȶöָ 

uint8_t PS_Search(uint8_t BufferID,uint16_t StartPage,uint16_t PageNum,SearchResult *p);//ָ 
 
uint8_t PS_RegModel(void);//ϲģ壩 
 
uint8_t PS_StoreChar(uint8_t BufferID,uint16_t PageID);//ģ 

uint8_t PS_DeletChar(uint16_t PageID,uint16_t N);//ɾģ 

uint8_t PS_Empty(void);//ָƿ 

uint8_t PS_WriteReg(uint8_t RegNum,uint8_t DATA);//дϵͳĴ 
 
uint8_t PS_ReadSysPara(SysPara *p); //ϵͳ 

uint8_t PS_SetAddr(uint32_t addr);  //ģַ 

uint8_t PS_WriteNotepad(uint8_t NotePageNum,uint8_t *content);//д± 

uint8_t PS_ReadNotepad(uint8_t NotePageNum,uint8_t *note);// 

uint8_t PS_HighSpeedSearch(uint8_t BufferID,uint16_t StartPage,uint16_t PageNum,SearchResult *p);// 
  
uint8_t PS_ValidTempleteNum(uint16_t *ValidN);//Чģ 

uint8_t PS_HandShake(uint32_t *PS_Addr); //AS608ģ

const char *EnsureMessage(uint8_t ensure);//ȷϢ

void Add_FR(void);

void press_FR(void);

void Del_FR(void);

void Del_FR_Lib(void);

#endif

